Subject: Re: linux-next: Tree for Dec 16 (drm_panel & intel_panel)

From: Steven Price <[email-masked]>
Date: Tue, 17 Dec 2019 11:52:29 +0000

On 17/12/2019 06:37, Randy Dunlap wrote:
> On 12/16/19 9:42 PM, Sam Ravnborg wrote:
>> Hi Randy.
>>
>> On Mon, Dec 16, 2019 at 08:25:11AM -0800, Randy Dunlap wrote:
>>> On 12/15/19 9:22 PM, Stephen Rothwell wrote:
>>>> Hi all,
>>>>
>>>> Changes since 20191213:
>>>>
>>>
>>> on x86_64:
>>>
>>> ld: drivers/gpu/drm/drm_panel.o: in function `drm_panel_of_backlight':
>>> (.text+0x2ee): undefined reference to `devm_of_find_backlight'
>>>
>>> ld: drivers/gpu/drm/i915/display/intel_panel.o: in function `intel_backlight_device_register':
>>> intel_panel.c:(.text+0x593e): undefined reference to `backlight_device_register'
>>> ld: drivers/gpu/drm/i915/display/intel_panel.o: in function `intel_backlight_device_unregister':
>>> intel_panel.c:(.text+0x5a04): undefined reference to `backlight_device_unregister'
>>>
>>> CONFIG_DRM_PANEL=y
>>> CONFIG_BACKLIGHT_CLASS_DEVICE=m
>>> CONFIG_DRM_I915=y
>>>
>>> Full randconfig file is attached.
>>
>> Can you please verify if you have:
>> 907aa265fde6589b8059dc51649c6d1f49ade2f3
>> ("drm/drm_panel: fix EXPORT of drm_panel_of_backlight")
>>
>> This commit is supposed to fix it.
>>
>> 	Sam
>>
> 
> Hi Sam,
> I don't have the linux-next.git tree so I can't check that.
> I just built whatever is in linux-next of 20191216.
> 

907aa265fde6589b8059dc51649c6d1f49ade2f3 ("drm/drm_panel: fix EXPORT of
drm_panel_of_backlight") is fixing drm_panel_of_backlight(), but the
error above is for backlight_device_register().

>From what I can tell, that commit is actually the cause of the error -
now intel_backlight_device_register() is being included in the kernel
even though it calls backlight_device_register() which is in a module.
Of course it also fixed the original error, so reverting it isn't any
use.

The below Kconfig change fixes the build for me, but I've no idea
whether this is the correct fix.

Steve

----8<-----
diff --git a/drivers/gpu/drm/i915/Kconfig b/drivers/gpu/drm/i915/Kconfig
index ba9595960bbe..6b69dab683ae 100644
--- a/drivers/gpu/drm/i915/Kconfig
+++ b/drivers/gpu/drm/i915/Kconfig
@@ -16,7 +16,7 @@ config DRM_I915
 	select IRQ_WORK
 	# i915 depends on ACPI_VIDEO when ACPI is enabled
 	# but for select to work, need to select ACPI_VIDEO's dependencies, ick
-	select BACKLIGHT_CLASS_DEVICE if ACPI
+	select BACKLIGHT_CLASS_DEVICE
 	select INPUT if ACPI
 	select ACPI_VIDEO if ACPI
 	select ACPI_BUTTON if ACPI